# gatk-coverage-reporter

An R script for re-calculating DP and AD fields reported by GATK somatic pipeline

## Descrpition

This R script calculates the real total depth and allelic depth for each 
varant reported by the GATK (somatic) variant calling pipelines, thus
correcting for the issue of GATK which reports the downsampled read and
allelic depths, as part of the internal algorithms, instead of the real depth.

The script performs the following tasks:
1. Reads the VCF file as a CollapsedVCF object using the Bioconductor package 
   VariantAnnotation
2. Reads the source BAM file (sorted/indexed on the fly if needed) using the 
   Bioconductor package GenomicAlignments (masked or not)
3. Loads the reference genome using the Bioconductor package BSgenome. If the 
   reference genome does not exist, it is downloaded and installed on the fly.
4. Based on variant locations, sequenced reads and CIGAR operations, retrieves 
   the actual coverage of each allele
5. Based on variant locations, retrieves the real total depth
6. Adds an INFO field named TAD field to the input VCF, containing the inferred AD
   (or replaces the original)
7. Adds an INFO field named TDP field to the input VCF, containing the inferred DP
   (or replaces the original)
8. Adds an INFO field named ObservedAlleleCount with the counts for each detected 
   allele, in the VCF file
9. Adds the respective fields in the VCF header with respective descrpitions
10. Exports the final VCF file and/or (see arguments) returns a ```CollapsedVCF```
   object to be used within R

The main implementation comes also with a shell script, ```runCoverageReporter.R```
that can be invoked from the system shell instead of the R shell, using ```Rscript```.

## Prerequisite R/Bioconductor packages
The following packages are required to run the script:
- GenomicAlignments
- GenomicRanges
- VariantAnnotation
- BSgenome
- BiocInstaller

## Main usage
### From within R
```
source(coverageReporter.R)
reportCoverage(
    vcf="my_gatk_vcf.vcf",
    bam="my_bam.bam",
    org="hg19"
)

# OR

source(coverageReporter.R)
nvcf <- reportCoverage(
    vcf="my_gatk_vcf.vcf",
    bam="my_bam.bam",
    org="hg19",
    fragLen=300,
    fracFac=2,
    dpCalc="pileup",
    output="my_corrected_output.vcf",
    indexOutput=TRUE,
    asObject=TRUE,
    rc=0.5
)

# OR
# see arguments
```

### From the shell
```
Rscript runCoverageReporter.R \
	--vcf=my_gatk_vcf.vcf \
	--bam=my_bam.bam \
	--org=hg19

# OR

Rscript runCoverageReporter.R \
	--vcf=my_gatk_vcf.vcf \
	--bam=my_bam.bam \
	--org=hg19 \
	--fraglen=300 \
	--fragfac=2 \
	--dpcalc=pileup \
	--output=my_corrected_output.vcf \
	--indexoutput \
	--corefraction=0.5
```

## List of arguments

The following table present the input arguments in detail:

|Parameter    |Description
|------------|-----------------------------------------------------------------------------------------------------------------------------------------------------|
|vcf         |A VCF file, usually the result of GATK pipeline for calling somatic mutations (Mutect, Mutect2).                                                     |
|bam         |The BAM file used to call mutations. Tumor only for now. Must be sorted/indexed. If not, it's done on the fly.                                       |
|org         |Supported organisms. One of ```"hg19"``` (default) or ```"hg38"```.                                                                                  |
|fragLen     |The average read length yielded by the instrument used for sequencing. Default is ```300``` (Illumina MiSeq). Together with the fracFac argument, it is used to define a region to mask the BAM file for speed and memory usage. Set to NULL in order to import the whole BAM file.                                        |
|fracFac     |A coefficient to multiply fragLen with. The final number is used to extend the variant locations read from the VCF file to define a region to mask the BAM file for speed. It defaults to ```2```. Set to a large number (e.g. ```100```) to ensure importing the whole BAM file.                                             |
|dpCalc      |How to calculate depth coverage. It can be ```"pileup"``` to use the allele coverage data collected by this script or ```"coverage"``` to use the native coverage Bioconductor method that operates on the ```*GAlignments*``` classes and is aware of CIGAR strings. Defaults to ```"pileup"``` as experience showed that native coverage does not always yield logical outcomes or slightly misplaced.                                                                                             |
|output      |An output filename (and path). If ```NULL``` (default) it is autogenerated by adding ```.dpcor``` to the file name (maintaining whatever extension). |
|indexOutput |Compress and index the output VCF file? Deaults to ```TRUE```.                                                                                       |
|asObject    |Return a ```CollapsedVCF``` object augmented by the measurements of script. If ```TRUE```, an object is returned to the R environment. Defaults to ```FALSE```.                                                                                                                                                       |
|pairedOpts  |A list of options to handle paired-end alignments. Keep in mind that treating a BAM file as paired-end increases significantly the read time as a pairing algorithm is applied. The list must have names (as options): a)```isPaired``` which denotes whether the input BAM file is the product of paired-end sequencing. It can be ```TRUE```, ```FALSE``` or ```NULL```. If ```NULL```, a test is conducted to check single or paired end configuration if asPaired is TRUE. Defaults to ```NULL```, b) ```asPaired```, treats BAM as single or paired even if it's paired. Defaults to ```FALSE```, as coverage and depth are not essentially depend on single or paired-end protocols but on actual reads covering the genomic area of interest, c) ```ifPaired```, which controls the GenomicAlignments function that will be used to read the BAM file. If ```"list"```, ```readGAlignmentsList``` will be used. If ```"pairs"```, ```readGAlignmentsPairs``` will be used. See the documentation of these functions for details.                                                                                                                                                           |
|replaceOrig  |Replace original DP, AD values or add new fields to the INFO and FORMAT columns (TDP, TAD). Defaults to FALSE (create new).                         |
|rc          |It can be ```NULL``` or a number between ```0``` and ```1``` which denotes the fraction of available cores to be used for parallel calculations in a  multicore machine and when package parallel is present. Defaults to ```NULL``` (do not use parallelism, 1 core, only option in Windows).                           |

## Inicative runtimes

On a rather old system with Ubuntu Server 14.04 LTS, 2 x AMD Opteron 6134 @2.3GHz, 16 cores total, 128GB RAM, the script tool (including loadind of R libraries, readinf BAM etc) for a ~800M BAM file and a VCF with 1160 records, kindly provided by Fotis Psomopoulos:

|# cores|time   |
|-------|-------|
|1      |11m 12s|
|8      |4m 10s |
|16     |4m     |

Clearly, more cores in this case do not make any difference as the load balancing is ineffective for these file sizes and the co-ordination of unnecessarily used cores. There should be a notable difference in larger files. Attention **must** be paid to memory usage with many cores as R is known for not managing memory in the best possible way.